<?php

namespace common\modules\product\controllers;

use common\modules\product\helpers\ProductHelper;
use common\modules\product\models\Category;
use common\modules\product\models\ProductImage;
use common\modules\product\models\ProductVariant;
use common\modules\product\models\RemoteProductsSearch;
use Yii;
use common\modules\product\models\Product;
use common\modules\product\models\ProductSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use common\modules\product\models\Brand;
use common\modules\product\models\BrandName;
use common\modules\product\models\RemoteProducts;
use yii\web\UploadedFile;

/**
 * ManageController implements the CRUD actions for Product model.
 */
class ManageController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    public function actionTest() {
        return;
        foreach(Product::find()->all() as $product) {
            if (!$product->variant) {
                $product->save();
                $variantModel = new ProductVariant();
                $variantModel->product_id = $product->product_id;
                $variantModel->name = 'test-'. uniqid();
                $variantModel->sku = $variantModel->name;
                $variantModel->price = rand(5, 200000);
                $variantModel->price_old = rand(0, 5) > 3 ? $variantModel->price* (1+rand(0, 10) / 10) : $variantModel->price;
                $variantModel->product_unit_id = rand(1, 5);
                $variantModel->stock = rand(0, 50);
                $variantModel->save();
            }
        }

        return;

        $categories = Category::find()->where(['depth' => 2])->all();
        $cats_ids = [];
        foreach($categories as $cat) {
            $cats_ids[] = $cat->category_id;
        }

        $brands = ProductHelper::getBrands()->all();
        $brands_ids = [];
        foreach($brands as $brand) {
            $brands_ids[] = $brand->brand_id;
        }

        for($i=1;$i<=1000;$i++) {
            $uniqid = uniqid();
            $model = new Product();
            $model->name = 'Test '. $uniqid;
            $model->brand_id = $brands_ids[array_rand($brands_ids, 1)];
            $model->categories = [$cats_ids[array_rand($cats_ids, 1)]];
            $model->save();

            $variantModel = new ProductVariant();
            $variantModel->product_id = $model->product_id;
            $variantModel->name = 'test-'. $uniqid;
            $variantModel->sku = $variantModel->name;
            $variantModel->price = rand(5, 200000);
            $variantModel->price_old = rand(0, 5) > 3 ? $variantModel->price* (1+rand(0, 10) / 10) : $variantModel->price;
            $variantModel->product_unit_id = rand(1, 5);
            $variantModel->save();
        }
    }

    /**
     * Lists all Product models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new ProductSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Product model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Product model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Product();

        if ($model->load(Yii::$app->request->post())) {
            $model->imagesUpload = UploadedFile::getInstances($model, 'imagesUpload');

            if ($model->save()) {
                foreach ($model->images as $image) {
                    $image->delete();
                }

                if ( ($images = $model->imagesUpload()) !== FALSE) {
                    foreach ($images as $image) {
                        $imageModel = new ProductImage();
                        $imageModel->product_id = $model->product_id;
                        $imageModel->image = $image;
                        $imageModel->save();
                    }
                }

                return $this->redirect(['view', 'id' => $model->product_id]);
            }
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Product model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post())) {
            $model->imagesUpload = UploadedFile::getInstances($model, 'imagesUpload');

            if ($model->save()) {
//                foreach ($model->images as $image) {
//                    $image->delete();
//                }

                if ( ($images = $model->imagesUpload()) !== FALSE) {
                    foreach ($images as $image) {
                        $imageModel = new ProductImage();
                        $imageModel->product_id = $model->product_id;
                        $imageModel->image = $image;
                        $imageModel->save();
                    }
                }

                return $this->redirect(['view', 'id' => $model->product_id]);
            }
        } else {
            $groups = $model->category->getTaxGroups();

            return $this->render('update', [
                'model' => $model,
                'groups' => $groups,
            ]);
        }
    }

    /**
     * Deletes an existing Product model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function actionDelimg($id)
    {
        $image = ProductImage::findOne($id);

        if ($image) {
            $image->delete();
        }

        print '1';
        exit;
    }

    public function actionIs_top($id) {
        $model = $this->findModel($id);

        $model->is_top = intval(empty($model->is_top));

        $model->save(false, ['is_top']);

        return $this->redirect(['index']);
    }

    public function actionIs_new($id) {
        $model = $this->findModel($id);

        $model->is_new = intval(empty($model->is_new));

        $model->save(false, ['is_new']);

        return $this->redirect(['index']);
    }

    public function actionImport() {
        $searchModel = new RemoteProductsSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('remote-products', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    public function actionImportStat() {
            $all_products = $new_products = $linked_products = $orpahed_products = 0;
            $remoteProducts = RemoteProducts::find()->all();

            $not_linked_cats = [];

            foreach($remoteProducts as $product) {
                if (!empty($product->product->product_id)) {
                    $linked_products++;
                } elseif (!empty($product->remoteCategory) && !empty($product->remoteCategory->category) && !empty($product->remoteCategory->category->category_id)) {
                    $new_products++;
                } else {
                    if (!empty($product->remoteCategory)) {
                        if (empty($not_linked_cats[$product->remoteCategory->ID])) {
                            $not_linked_cats[$product->remoteCategory->ID] = $product->remoteCategory->Name ." (". $product->remoteCategory->ID .")";
                        }
                    }
                    $orpahed_products++;
                }
                $all_products++;
            }

        $op = [];

            $op[] = "Всего $all_products товаров, $new_products новых и $linked_products уже связанных.";
            if (!empty($not_linked_cats)) {
                $op[] = "$orpahed_products товаров не привязаны к категориям:";
                foreach ($not_linked_cats as $not_linked_cat) {
                    $op[] = "$not_linked_cat";
                }
            }

        return $this->render('import-stat', [
            'all_products' => $all_products,
            'new_products' => $new_products,
            'linked_products' => $linked_products,
            'orpahed_products' => $orpahed_products,
            'not_linked_cats' => $not_linked_cats,
        ]);
    }

    /**
     * Finds the Product model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Product the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Product::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}
